From db44fa520de4c61ccedd328dd7239610c4f8ec30 Mon Sep 17 00:00:00 2001
From: Meghan Richardson <mrichard@fedoraproject.org>
Date: Jul 07 2015 21:36:02 +0000
Subject: [PATCH 175/1001] Merge branch 'develop' of pagure.io:fedora-hubs into develop


---

diff --git a/hubs/app.py b/hubs/app.py
index bca015e..cac231f 100644
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -50,6 +50,12 @@ class CustomJSONEncoder(flask.json.JSONEncoder):
 app.json_encoder = CustomJSONEncoder
 
 
+@app.teardown_request
+def shutdown_session(exception=None):
+    """ Remove the DB session at the end of each request. """
+    session.remove()
+
+
 @app.route('/')
 def index():
     if not flask.g.auth.logged_in:
@@ -249,6 +255,27 @@ def hub_unsubscribe(hub):
     session.commit()
     return flask.redirect(flask.url_for('hub', name=hub.name))
 
+@app.route('/api/hub/<hub>/star', methods=['POST'])
+@login_required
+def hub_star(hub):
+    hub = get_hub(session, hub)
+    user = hubs.models.User.by_openid(session, flask.g.auth.openid)
+    hub.subscribe(session, user, role='stargazer')
+    session.commit()
+    return flask.redirect(flask.url_for('hub', name=hub.name))
+
+@app.route('/api/hub/<hub>/unstar', methods=['POST'])
+@login_required
+def hub_unstar(hub):
+    hub = get_hub(session, hub)
+    user = hubs.models.User.by_openid(session, flask.g.auth.openid)
+    try:
+        hub.unsubscribe(session, user, role='stargazer')
+    except KeyError:
+        return flask.abort(400)
+    session.commit()
+    return flask.redirect(flask.url_for('hub', name=hub.name))
+
 @app.route('/api/hub/<hub>/join', methods=['POST'])
 @login_required
 def hub_join(hub):
diff --git a/hubs/models.py b/hubs/models.py
index ff117ab..ef97536 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -83,7 +83,7 @@ def init(db_url, debug=False, create=False):
     return scoped_session(sessionmaker(bind=engine))
 
 
-roles = ['subscriber', 'member', 'owner']
+roles = ['subscriber', 'member', 'owner', 'stargazer']
 
 
 class Association(BASE):
@@ -95,7 +95,7 @@ class Association(BASE):
     user_id = sa.Column(sa.Text,
                         sa.ForeignKey('users.openid'),
                         primary_key=True)
-    role = sa.Column(sa.Enum(*roles), nullable=False)
+    role = sa.Column(sa.Enum(*roles), primary_key=True)
 
     user = relation("User", backref="associations")
     hub = relation("Hub", backref="associations")
@@ -126,6 +126,7 @@ class Hub(BASE):
     def owners(self):
         return [assoc.user for assoc in self.associations
                 if assoc.role == 'owner']
+
     @property
     def members(self):
         return [assoc.user for assoc in self.associations
@@ -136,6 +137,11 @@ class Hub(BASE):
         return [assoc.user for assoc in self.associations
                 if assoc.role == 'subscriber']
 
+    @property
+    def stargazers(self):
+        return [assoc.user for assoc in self.associations
+                if assoc.role == 'stargazer']
+
     def subscribe(self, session, user, role='subscriber'):
         """ Subscribe a user to this hub. """
         # TODO -- add logic here to manage not adding the user multiple
@@ -284,6 +290,19 @@ class User(BASE):
                 if assoc.role == 'subscriber']
 
     @property
+    def starred_hubs(self):
+        return [assoc.hub for assoc in self.associations
+                if assoc.role == 'stargazer']
+
+    @property
+    def bookmarks(self):
+        # TODO -- someday make this editable/configurable.
+        return sorted(list(set([assoc.hub for assoc in self.associations
+                if assoc.role == 'member'
+                or assoc.role == 'subscriber'
+                or assoc.role == 'owner'])))
+
+    @property
     def username(self):
         return self.openid.split('.')[0]
 
diff --git a/hubs/widgets/about.py b/hubs/widgets/about.py
index b0df6cc..84b8de7 100644
--- a/hubs/widgets/about.py
+++ b/hubs/widgets/about.py
@@ -10,7 +10,7 @@ import hubs.validators as validators
 template = jinja2.Template("""
     <p>{{text}}</p>
     """)
-chrome = panel("About")
+chrome = panel("<span class='glyphicon glyphicon-info-sign' aria-hidden='true'></span> About")
 
 
 @argument(name="text", default="I am a Fedora user, and this is my about",
diff --git a/hubs/widgets/stats.py b/hubs/widgets/stats.py
index 31205c4..228d60f 100644
--- a/hubs/widgets/stats.py
+++ b/hubs/widgets/stats.py
@@ -6,35 +6,46 @@ import jinja2
 
 chrome = panel()
 template = jinja2.Template("""
-<div class="stats-container">
+<div class="stats-container row">
+<div class="col-md-7">
   <table class="stats-table">
     <tr><th>Members</th><th>Subscribers</th></tr>
     <tr class="text-info"><td>{{members | length}}</td><td class="text-right">{{subscribers | length}}</td></tr>
   </table>
+</div>
+<div class="col-md-5">
+  <ul class="list-unstyled">
+  {% if g.auth.nickname in subscribers %}
+  <li><form action="{{hub_unsubscribe_url}}" method="POST">
+      <button class="btn btn-info"><span class="glyphicon glyphicon-remove-sign" aria-hidden="true"></span> Unsubscribe</button>
+  </form></li>
+  {% else %}
+  <li><form action="{{hub_subscribe_url}}" method="POST">
+      <button class="btn btn-default"><span class="glyphicon glyphicon-ok-sign" aria-hidden="true"></span> Subscribe</button>
+  </form></li>
+  {% endif %}
+
+  {% if g.auth.nickname in stargazers %}
+  <li><form action="{{hub_unstar_url}}" method="POST">
+      <button class="btn btn-info"><span class="glyphicon glyphicon-remove-sign" aria-hidden="true"></span> Unstar Hub</button>
+  </form></li>
+  {% else %}
+  <li><form action="{{hub_star_url}}" method="POST">
+      <button class="btn btn-default"><span class="glyphicon glyphicon-ok-sign" aria-hidden="true"></span> Star Hub</button>
+  </form></li>
+  {% endif %}
 
-  {% if g.auth.logged_in %}
-    <div class="pull-right">
-    {% if g.auth.nickname in members %}
-    <form action="{{hub_leave_url}}" method="POST">
-        <button class="btn btn-danger">Leave Hub</button>
-    </form>
-    {% elif g.auth.nickname in subscribers %}
-    <form action="{{hub_unsubscribe_url}}" method="POST">
-        <button class="btn btn-warning"><span class="glyphicon glyphicon-remove-sign" aria-hidden="true"></span> Unsubscribe</button>
-    </form>
-    {% else %}
-    <form action="{{hub_subscribe_url}}" method="POST">
-        <button class="btn btn-info"><span class="glyphicon glyphicon-ok-sign" aria-hidden="true"></span> Subscribe</button>
-    </form>
-    {% endif %}
-    </div>
+  {% if g.auth.nickname in members %}
+  <li><form action="{{hub_leave_url}}" method="POST">
+      <button class="btn btn-info"><span class="glyphicon glyphicon-remove-sign" aria-hidden="true"></span> Leave Hub</button>
+  </form></li>
   {% else %}
-    <div class="pull-right">
-        <form action="{{hub_subscribe_url}}" method="POST">
-            <button class="btn btn-info">Subscribe</button>
-        </form>
-    </div>
+  <li><form action="{{hub_join_url}}" method="POST">
+      <button class="btn btn-default"><span class="glyphicon glyphicon-ok-sign" aria-hidden="true"></span> Join Hub</button>
+  </form></li>
   {% endif %}
+  </ul>
+</div>
 </div>
 """)
 
@@ -44,8 +55,12 @@ def data(session, widget):
         owners=[u.username for u in widget.hub.owners],
         members=[u.username for u in widget.hub.members],
         subscribers=[u.username for u in widget.hub.subscribers],
+        stargazers=[u.username for u in widget.hub.stargazers],
+
         hub_leave_url=flask.url_for('hub_leave', hub=widget.hub.name),
         hub_join_url=flask.url_for('hub_join', hub=widget.hub.name),
+        hub_unstar_url=flask.url_for('hub_unstar', hub=widget.hub.name),
+        hub_star_url=flask.url_for('hub_star', hub=widget.hub.name),
         hub_subscribe_url=flask.url_for('hub_subscribe', hub=widget.hub.name),
         hub_unsubscribe_url=flask.url_for('hub_unsubscribe', hub=widget.hub.name),
     )
diff --git a/populate.py b/populate.py
index 4e5fa75..44699ac 100755
--- a/populate.py
+++ b/populate.py
@@ -11,7 +11,8 @@ fedmsg_config = fedmsg.config.load_config()
 session = hubs.models.init(fedmsg_config['hubs.sqlalchemy.uri'], True, True)
 
 users = ['mrichard', 'duffy', 'ryanlerch', 'gnokii', 'nask0',
-         'abompard', 'decause', 'ralph', 'lmacken']
+         'abompard', 'decause', 'ralph', 'lmacken', 'croberts', 'mattdm',
+         'pravins']
 for username in users:
     fullname = 'Full Name Goes Here'
     openid = '%s.id.fedoraproject.org' % username
@@ -21,8 +22,88 @@ for username in users:
 
 session.commit()
 
+############## Internationalizationteam
+hub = hubs.models.Hub(name='Internationalizationteam', summary='The Fedora Internationalization Team')
+session.add(hub)
 
-############## Infra team
+widget = hubs.models.Widget(plugin='stats', index=0)
+hub.widgets.append(widget)
+widget = hubs.models.Widget(plugin='rules', index=1,
+                            _config=json.dumps({
+                                'link': 'https://fedoraproject.org/wiki/I18N'
+                            }))
+hub.widgets.append(widget)
+
+widget = hubs.models.Widget(plugin='dummy', index=2)
+hub.widgets.append(widget)
+
+# Added a hubs about widget
+widget = hubs.models.Widget(plugin='about', index=3,
+                            _config=json.dumps({
+                                "text": "I'm a Fedora user, and this is my about widget text!",
+                            }))
+hub.widgets.append(widget)
+
+widget = hubs.models.Widget(plugin='sticky', index=0, left=True,
+                            _config=json.dumps({
+                                'text': "<p>The Fedora I18N project works on internationalization (i18n) to support the localization (l10n) of Fedora in many languages. Translation of Fedora software and documentation are handled by the Fedora L10N project.</p> <p>The goals of the Project are to:</p> <ul><li>Develop, package, and maintain applications like input methods for different languages</li> <li>Improve applications and utilities to support and process different languages</li> <li>Quality-assure that existing applications meet i18n standards</li> <li>Support the infrastructure of the Fedora Localization Project</li></ul>",
+                            }))
+hub.widgets.append(widget)
+widget = hubs.models.Widget(plugin='dummy', index=1, left=True)
+hub.widgets.append(widget)
+
+
+# Set up some memberships
+hub.subscribe(session, hubs.models.User.by_openid(session, 'pravins.id.fedoraproject.org'), 'owner')
+hub.subscribe(session, hubs.models.User.by_openid(session, 'decause.id.fedoraproject.org'), 'member')
+hub.subscribe(session, hubs.models.User.by_openid(session, 'ralph.id.fedoraproject.org'), 'subscriber')
+
+
+session.commit()
+
+############## Marketing team
+hub = hubs.models.Hub(name='marketingteam', summary='The Fedora Marketing Team')
+session.add(hub)
+
+widget = hubs.models.Widget(plugin='stats', index=0)
+hub.widgets.append(widget)
+widget = hubs.models.Widget(plugin='rules', index=1,
+                            _config=json.dumps({
+                                'link': 'https://fedoraproject.org/wiki/Marketing'
+                            }))
+hub.widgets.append(widget)
+
+widget = hubs.models.Widget(plugin='dummy', index=2)
+hub.widgets.append(widget)
+
+# Added a hubs about widget
+widget = hubs.models.Widget(plugin='about', index=3,
+                            _config=json.dumps({
+                                "text": "I'm a Fedora user, and this is my about widget text!",
+                            }))
+hub.widgets.append(widget)
+
+widget = hubs.models.Widget(plugin='sticky', index=0, left=True,
+                            _config=json.dumps({
+                                'text': "The Fedora Marketing Team develops and executes marketing strategies to promote the usage and support of Fedora worldwide. Through the development of processes and content, this project aims to support the efforts of other Fedora projects to spread Fedora and to provide a central repository of ideas and information that can be used to deliver Fedora to new audiences. We work closely with the Fedora Ambassadors who spread the word about Fedora at events and allow the Fedora Project to interact directly with its existing and prospective users. ",
+                            }))
+hub.widgets.append(widget)
+widget = hubs.models.Widget(plugin='dummy', index=1, left=True)
+hub.widgets.append(widget)
+
+
+# Set up some memberships
+hub.subscribe(session, hubs.models.User.by_openid(session, 'croberts.id.fedoraproject.org'), 'owner')
+hub.subscribe(session, hubs.models.User.by_openid(session, 'ryanlerch.id.fedoraproject.org'), 'owner')
+hub.subscribe(session, hubs.models.User.by_openid(session, 'mrichard.id.fedoraproject.org'), 'member')
+hub.subscribe(session, hubs.models.User.by_openid(session, 'mattdm.id.fedoraproject.org'), 'member')
+hub.subscribe(session, hubs.models.User.by_openid(session, 'decause.id.fedoraproject.org'), 'member')
+hub.subscribe(session, hubs.models.User.by_openid(session, 'ralph.id.fedoraproject.org'), 'subscriber')
+
+
+session.commit()
+
+############## Design team
 hub = hubs.models.Hub(name='designteam', summary='The Fedora Design Team')
 session.add(hub)
 
@@ -30,7 +111,7 @@ widget = hubs.models.Widget(plugin='stats', index=0)
 hub.widgets.append(widget)
 widget = hubs.models.Widget(plugin='rules', index=1,
                             _config=json.dumps({
-                                'link': 'http://threebean.org'
+                                'link': 'https://fedoraproject.org/wiki/Design'
                             }))
 hub.widgets.append(widget)
 
@@ -62,6 +143,8 @@ hub.subscribe(session, hubs.models.User.by_openid(session, 'nask0.id.fedoraproje
 hub.subscribe(session, hubs.models.User.by_openid(session, 'decause.id.fedoraproject.org'), 'member')
 hub.subscribe(session, hubs.models.User.by_openid(session, 'ralph.id.fedoraproject.org'), 'subscriber')
 
+session.commit()
+
 
 ############## Infra team
 hub = hubs.models.Hub(name='infrastructure', summary='The Fedora Infrastructure Team')
@@ -71,7 +154,7 @@ widget = hubs.models.Widget(plugin='stats', index=0)
 hub.widgets.append(widget)
 widget = hubs.models.Widget(plugin='rules', index=1,
                             _config=json.dumps({
-                                'link': 'http://threebean.org'
+                                'link': 'https://fedoraproject.org/wiki/Infrastructure'
                             }))
 hub.widgets.append(widget)
 

